using System;
using System.EnterpriseServices;
using System.Windows.Forms;

namespace ComPlus1
{	
	[ObjectPooling(true, 3, 10)]
	[JustInTimeActivation(true)]
	public class Pooled:ServicedComponent
	{
		private static int ObjectCounter = 0;
		private int ObjectId;		
		public Pooled()
		{
			System.Threading.Interlocked.Increment(ref ObjectCounter);
			ObjectId = ObjectCounter;

			//lengthy constructor code
			MessageBox.Show("Pooled Constructor", ObjectId.ToString());			
		}

		public void Test()
		{
			MessageBox.Show("Method Running", ObjectId.ToString());
			ContextUtil.DeactivateOnReturn = true;
		}

		protected override void Activate()
		{
			MessageBox.Show("Activate", ObjectId.ToString());
			base.Activate ();
		}
		protected override void Deactivate()
		{
			MessageBox.Show("DeActivate", ObjectId.ToString());
			base.Deactivate ();
		}
		protected override bool CanBePooled()
		{
			MessageBox.Show("CanBePooled", ObjectId.ToString());
			return true;
		}

		~Pooled()
		{
			System.Threading.Interlocked.Decrement(ref ObjectCounter);
		}

	}
}
